<?php
// $Id: comment_subject.token.inc,v 1.2 2010/01/13 14:27:49 sinasalek Exp $

function comment_subject_token_list($type = 'all') {
  if ($type == 'comment' || $type == 'all') {
    $tokens = array();

    $tokens['comment'] = array(
      'comment-pid'                   => t('Comment\'s parent ID (just for parent being another comment, otherwise zero)'),
      'comment-parent-title'          => t('Paren\'s title (the parent might be the node or a another comment)'),
      'comment-parent-title-raw'      => t('Paren\'s title. WARNING - raw user input'),
      'comment-auto-numbering'        => t('Auto-numbering with respect to node\'s comments count.'),
      'comment-parent-auto-numbering' => t('Parent\'s auto-numbering with respect to node\'s comments count.'),
    );
    
    return $tokens;
  }
}

function comment_subject_token_values($type, $object = NULL) {
  if ($type == 'comment') {
    $comment = (object)$object;
    // @TODO: support uninitialized pid? (forms might have it uninitialized)
    if (!isset($comment->pid)) $comment->pid = 0;
    
    // [comment-parent-title-raw]
    if ($comment->pid) { 
      $parent = _comment_load($comment->pid);
      $parent_title = $parent->subject;
    }
    else {
      $parent = node_load($comment->nid);
      $parent_title = $parent->title;
    }
    
    // [comment-parent-auto-numbering]
    $parent_numbering = _comment_subject_get_parent_numbering($comment);
    
    // [comment-auto-numbering]
    $comment_numbering = _comment_subject_get_numbering($comment);
    
    $tokens['comment-pid']                   = $comment->pid;
    $tokens['comment-parent-title']          = check_plain($parent_title);
    $tokens['comment-parent-title-raw']      = $parent_title;
    $tokens['comment-auto-numbering']        = $comment_numbering;
    $tokens['comment-parent-auto-numbering'] = $parent_numbering;
    
    return $tokens;
  }
}
